/*=========================================================================

    This file is part of vtkPOpenFOAMReader.

    vtkPOpenFOAMReader is free software: you can redistribute it
    and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation, either version 3 of
    the License, or (at your option) any later version.

    vtkPOpenFOAMReader is distributed in the hope that it will be
    useful, but WITHOUT ANY WARRANTY; without even the implied
    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
    See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with vtkPOpenFOAMReader.  If not, see
    <http://www.gnu.org/licenses/>.

=========================================================================*/
// Copyright (c) 2008 Takuya OSHIMA <oshima@eng.niigata-u.ac.jp>.
// All rights reserved.
// Date: 2008-08-31

#include "pqOpenFOAMPanel.h"

// Qt
#include <QPushButton>
#include <QLayout>

// server manager
#include "vtkSMProperty.h"
#include "vtkSMSourceProxy.h"

//-----------------------------------------------------------------------------
pqOpenFOAMPanel::pqOpenFOAMPanel(pqProxy *pxy, QWidget *p)
  : pqAutoGeneratedObjectPanel(pxy, p)
{
  // create refresh button
  QPushButton *refresh = new QPushButton("Refresh", this);
  refresh->setSizePolicy(QSizePolicy::Fixed, QSizePolicy::Fixed);
  // place the button at top-right of the layout grid
  this->PanelLayout->addWidget(refresh, 0, 1, Qt::AlignRight);
  QObject::connect(refresh, SIGNAL(clicked()), this, SLOT(onRefresh()));
  vtkSMSourceProxy::SafeDownCast(this->proxy())->GetProperty("Refresh")
    ->SetImmediateUpdate(1);
}

//-----------------------------------------------------------------------------
void pqOpenFOAMPanel::onRefresh()
{
  vtkSMSourceProxy* sp = vtkSMSourceProxy::SafeDownCast(this->proxy());
  sp->GetProperty("Refresh")->Modified();
  // force updating everything (RequestInformation() + RequestData())
  sp->UpdatePipeline();
}
